//SledgeHammer.cs
datablock AudioProfile(SledgeHammerDrawSound)
{
   filename    = "./swordDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(SledgeHammerHitSound)
{
   filename    = "./Smash.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(SledgeHammerExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "0.2 0.1 0.1 0.9";
   colors[1]     = "0.5 0.5 0.5 0.9";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(SledgeHammerExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SledgeHammerExplosionParticle";

   uiName = "SledgeHammer Hit";
};

datablock ExplosionData(SledgeHammerExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = SledgeHammerHitSound;

   particleEmitter = SledgeHammerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "2.0 2.0 2.0";
   camShakeDuration = 1;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.4 0.1 0.1";
   lightEndColor = "0 0 0";

   //radius damage
   radiusDamage        = 40;
   damageRadius        = 1;
};


//projectile
AddDamageType("SledgeHammer",   '<bitmap:add-ons/Weapon_SledgeHammer/CI_SledgeHammer> %1',    '%2 <bitmap:add-ons/Weapon_SledgeHammer/CI_SledgeHammer> %1',0.75,1);
datablock ProjectileData(SledgeHammerProjectile)
{
   directDamage        = 70;
   directDamageType  = $DamageType::SledgeHammer;
   radiusDamageType  = $DamageType::SledgeHammer;
   explosion           = SledgeHammerExplosion;
   //particleEmitter     = as;

   brickExplosionRadius = 1.5;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 25;
   brickExplosionMaxVolume = 45;
   brickExplosionMaxVolumeFloating = 45;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "SledgeHammer Hit";
};


//////////
// item //
//////////
datablock ItemData(SledgeHammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SledgeHammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SledgeHammer";
	iconName = "./icon_SledgeHammer";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = SledgeHammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SledgeHammerImage)
{
   // Basic Item properties
   shapeFile = "./SledgeHammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SledgeHammerItem;
   ammo = " ";
   projectile = SledgeHammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = SledgeHammerDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "StopMoving";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "StopMoving";
	statescript[4]			= "onStopFire";
	stateTransitionOntimeout[4]		= "CheckFire";
	stateTimeoutValue[4]		= 1.0;

	stateName[5]			= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Prefire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                  = "onStopFire";


};

function SledgeHammerImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function SledgeHammerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

//function SledgeHammerProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
//{
//   Parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
//   if(%col.getType() & $TypeMasks::PlayerObjectType)
//   {
//      %col.setplayerscale(0.5);
//   }
//}